// Processing code for this example
 
 // Graphing sketch
 
 
 // This program takes ASCII-encoded strings
 // from the serial port at 9600 baud and graphs them. It expects values in the
 // range 0 to 1023, followed by a newline, or newline and carriage return
 
 // Created 20 Apr 2005
 // Updated 18 Jan 2008
 // by Tom Igoe
 // This example code is in the public domain.
 
 import processing.serial.*;
 static final int WINDOW_X = 100, WINDOW_Y = 100;
 
 int nval=4;//nombre de valeurs par ligne - separateur=espace - 12 valeur par ligne maxi
 float[] val_lues= new float[nval]; 
 float[] moy =  {0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00};
 float[] gains= {1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00,1.00}; 
 float[] minima={20.0,20.0,20.0,20.0,20.0,20.0,20.0,20.0,20.0,20.0,20.0,20.0}; 
 float[] maxima={30.0,30.0,30.0,30.0,30.0,30.0,30.0,30.0,30.0,30.0,30.0,30.0}; 
 String[] legende={"T1","T3","T10","T100","??","??","??","??","??","T??","??","??"};
 int[] croug={255,0,0,0,255,255,128,0,0,0,128,128}; 
 int[] cvert={0,255,0,255,0,255,0,128,0,128,0,128}; 
 int[] cbleu={0,0,255,255,255,0,0,0,128,128,128,0}; 
 
 Serial myPort;        // The serial port
 String inString ;
 int xPos = 1;         // horizontal position of the graph
 long temps0, temps1;
 float dt2, dt1;
 int cnt = 1, freq = 1 ;  // on ecrit toutes les freq lectures - moyenne sur freq valeurs
 // Declare Font
 PFont h1;

 PrintWriter output;
 boolean outputInitialized = false;
 
 
void setup () {
 // set the window size:
   frame.setLocation(WINDOW_X, WINDOW_Y);

 size(800, 600);
 // List all the available serial ports
 println(Serial.list());
 println(day() + "/" + month() + "/" + year() + "-" + hour() + ":" + minute() + ":" + second());
 // I know that the first port in the serial list on my mac
 // is always my  Arduino, so I open Serial.list()[0].
 // Open whatever port is the one you're using.
 myPort = new Serial(this, Serial.list()[0],9600);
 // don't generate a serialEvent() unless you get a newline character:
 myPort.bufferUntil('\n');
 // set inital background, axis lines and title:
 background(0);
 stroke(255,255,255); strokeWeight(1);
 line(0,height,0,0); line(0,height,width,height);
 //font "Courier Italic"  "SansSerif.italic"
 //printArray(PFont.list());
 h1 = createFont("Courier", 16);
 textFont(h1); textAlign(LEFT, CENTER); textSize(16);
   for (int i = 0; i < nval; i = i+1) {
    fill(croug[i],cvert[i],cbleu[i]); text(legende[i],3,(20+i*20));
  }
 fill(255,255,255); text("temps",width/2,height-20);
 // Create a new file in the sketch directory
 output = createWriter("valeurs.txt"); outputInitialized = true;
 //ecrire l'entete de fichier
 if (outputInitialized) { 
  output.println(day() + "/" + month() + "/" + year() + "-" + hour() + ":" + minute() + ":" + second());
  output.print("temps ");
  for (int i = 0; i < (nval-1); i = i+1) {
    output.print(legende[i] + " ");
  }
  output.println(legende[nval-1]);
  output.flush();
 }
 // 
 temps0 = System.currentTimeMillis();
 println("t0=" + temps0 + " en millisecondes");
}
 
 
void draw () {
 // everything happens in the serialEvent()
 // dessiner les valeurs a l'ecran
 if (inString != null) {//  println("inString=" + inString + "-fin de inString");
  String inStringloc = trim(inString);
  inString = null;
  int isepare=0; int ilength=0; String inVoie=null;
  for (int i = 0; i < nval; i = i+1) {
   isepare = inStringloc.indexOf(' '); ilength = inStringloc.length();
   if (isepare>-1) {
    inVoie = inStringloc.substring(0,isepare) ;
    inStringloc = trim(inStringloc.substring(isepare+1,ilength));
   }
   else {
    inVoie = inStringloc;
   }
   val_lues[i]=float(inVoie);
   moy[i]=moy[i]+val_lues[i];
  }
  // recuperer le temps actuel
  temps1 = System.currentTimeMillis();
  dt2 = dt1; dt1 = float(int(temps1 - temps0));
  // ecrire les lectures a l'ecran
  print("temps=" + (dt1/1000.0) + " en secondes, dt=" + ((dt1 - dt2)/1000.0) + ", ");
  for (int i = 0; i < nval-1; i = i+1) {
   print(legende[i] + "=" + val_lues[i] + ", ");
  }
  println(legende[nval-1] + "=" + val_lues[nval-1]);
  if (cnt == freq) {
   for (int i = 0; i < nval; i = i+1) {moy[i]=moy[i]/freq;}
   println(" moyennes sur= " + freq + " valeur(s)" + "temps=" + (dt1/1000.0) + "s ");
   // ecrire les moyennes dans output et a l'ecran
   if (outputInitialized) {
    output.print((dt1/1000.0) + " ");
    for (int i = 0; i < nval-1; i = i+1) {
     output.print(moy[i] + " ");
     print(legende[i] + "=" + moy[i] + ", ");
    }
    output.println(moy[nval-1]);
    println(legende[nval-1] + "=" + moy[nval-1]);
    output.flush();
   }
   for (int i = 0; i < nval; i = i+1) {moy[i]=0;}
   cnt=0; 
  }
  // dessiner les valeurs a l'ecran
  for (int i = 0; i < nval; i = i+1) {
   val_lues[i]=gains[i]*val_lues[i];
   val_lues[i]=map(val_lues[i],minima[i],maxima[i],0,height);
   stroke(croug[i],cvert[i],cbleu[i]);
   strokeWeight(2);
   point(xPos, height - val_lues[i]);
  }
  //tracer 3 lignes noires en amont pour effacer
  stroke(0,0,0);line(xPos+1,0,xPos+1,height);
  stroke(0,0,0);line(xPos+2,0,xPos+2,height);
  stroke(0,0,0);line(xPos+3,0,xPos+3,height);
  //remetrre les legendes effacees par les 3 lignes
  for (int i = 0; i < nval; i = i+1) {
   fill(croug[i],cvert[i],cbleu[i]); text(legende[i],3,(20+i*20));
  }
  fill(255,255,255); text("temps",width/2,height-20);
  stroke(255,255,255);
  line(0,height,0,0); line(0,height,width,height);
     //positionner au debut en bout de ligne
  if (xPos >= width) {
   xPos = 0;
  }
   // increment the horizontal position:
  else {xPos++;}
   // incrementation du compteur
  cnt = cnt + 1;
 }
}
 
 void serialEvent (Serial myPort) {
 // get the ASCII string:
 inString = myPort.readStringUntil('\n');
}

void keyPressed() {
  output.flush(); // Writes the remaining data to the file
  output.close(); // Finishes the file
  exit(); // Stops the program
}